coffee = require 'coffee-script'
sys = require 'sys'
exec = require('child_process').exec
fs = require 'fs'

# npm install file
nfile = require 'file'

# npm install wrench
# for rmdirSyncRecursive:
wrench = require "wrench"

# npm install jsmin
# for minifying code:
jsmin = require('jsmin').jsmin

# npm install lingo
# for generating models, etc...
lingo = require('lingo')

@CoffeeGrinder = {
  version: '0.0.0'
  app_name: 'unknown'
  header: ''
  model_module: ''
}

exports.CoffeeGrinder = @CoffeeGrinder

task "describe", =>
  console.log @CoffeeGrinder

task "test", (options) =>
  invoke 'build'
  exec "bundle exec jasmine-headless-webkit", (error, stdout, stderr)->
    console.log stdout

task 'clean', (options) =>
  try
    wrench.rmdirSyncRecursive 'builds'
  catch error

task 'build', (options) =>
  invoke 'clean'
  fs.mkdirSync 'builds', '0777'
  
  bigFile = @CoffeeGrinder.header
  
  for dir in ['app', 'lib']
    nfile.walkSync dir, (start, dirs, names)->
      for name in names
        path = [start, name].join('/')
        try
          bigFile += fs.readFileSync path, 'utf-8'
          bigFile += "\n\n"
        catch error

  compiled = coffee.compile(bigFile)
  fs.writeFileSync "builds/#{@CoffeeGrinder.app_name}.edge.js", compiled
  fs.writeFileSync "public/js/#{@CoffeeGrinder.app_name}.js", compiled
  
  console.log 'Finished building'
  
task 'release', (options) =>
  invoke 'build'
  fs.writeFileSync "builds/#{@CoffeeGrinder.app_name}-#{@CoffeeGrinder.version}.js", fs.readFileSync("builds/#{@CoffeeGrinder.app_name}.edge.js", 'utf-8')
  fs.writeFileSync "builds/#{@CoffeeGrinder.app_name}-#{@CoffeeGrinder.version}.min.js", jsmin(fs.readFileSync("builds/#{@CoffeeGrinder.app_name}.edge.js", 'utf-8'))
  
option '-n', '--name [NAME]', 'name of the model'
task 'generate:model', (options)=>
  name = options.name.replace(/\_/, ' ')
  name = lingo.camelcase(name, true)

  model_name = "#{@CoffeeGrinder.model_module}#{name}"
  model = """class @#{model_name} extends Backbone.Model"""

  fs.writeFileSync "app/models/#{options.name}.coffee", model

  spec = """
describe "#{model_name}", ->

  beforeEach ->
    @#{options.name} = new #{model_name}()

  it "should do something", ->
    console.log "pending..."

"""

  fs.writeFileSync "spec/javascripts/models/#{options.name}_spec.coffee", spec